package ru.scancode.GodexPrintTest;

import android.os.Bundle;
import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

/**
 * Вкладка тестирования отправки параметров (в т.ч. QR) в XML-формате
 * @author Vaganov
 */
public class XMLPage extends AbstractPage{

    static String PAGENAME = "XMLPage";

    private Button CustomCommandBtn;
    private Button doubleCheckStatusCommandBtn;

    private static final String DATA = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?><cmd name=\"print\"><parameters><parameter name=\"TMH_Label_58_40_my\" type=\"template\"><value name=\"QRCode\" type=\"variable\" value=\"{\"Номенклатура\":{\"КодАМТО\":\"000001\",\"ЕдиницаИзмеренияКод\":\"796 \",\"Характеристика\":\"\"},\"Серия\":{\"Наименование\":\"\",\"Номер\":\"\",\"ДатаПроизводства\":\"01.01.0001 0:00:00\",\"СрокГодности\":\"01.01.0001 0:00:00\"},\"Спецификация\":{\"Номер\":null,\"Дата\":\"\"},\"Грузоотправитель\":{\"ИНН\":\"\",\"КПП\":\"\"},\"Поставщик\":{\"ИНН\":\"\",\"КПП\":\"\"}}\"/><value name=\"Name\" type=\"variable\" value=\"Х-67890 Стинол Завод бытовой техники\"/></parameter><parameter name=\"\" type=\"quantity\"><value type=\"count\" value=\"1\" /></parameter></parameters></cmd>";
    private static final String DATA2 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"print\">\n" +
            "\t<parameters>\n" +
            "\t\t<parameter name=\"TMH_Label_58_40_my\" type=\"template\">\n" +
            "\t\t\t<value type=\"variable\" name=\"QRCode\" value=\"123456\"/>\n" +
            "\t\t\t<value name=\"Name\" type=\"variable\" value=\"Х-67890 Стинол Завод бытовой техники\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA3 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"print\">\n" +
            "\t<parameters>\n" +
            "\t\n" +
            "\t\t<parameter name=\"mytemplate3params\" type=\"template\">\n" +
            "\t\t\t<value type=\"variable\" name=\"QRCode\" value=\"In another moment down went Alice after it, never once considering how in the world she was to get out again.\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Name\" value=\"Холодильник Стинол\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Manufacter\" value=\"НЛМК\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA4 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"print\">\n" +
            "\t<parameters>\n" +
            "\t\n" +
            "\t\t<parameter name=\"mytemplate3params\" type=\"template\">\n" +
            "\t\t\t<value type=\"variable\" name=\"QRCode\" value=\"Code=000004|UnitCode=715|Characteristic=40, Коричневый, 6, натуральная кожа|SerName=|SerNumber=|ProdDate=01.01.0001 0:00:00|ExpDate=01.01.0001 0:00:00|DocNo=|DocDate=01.01.0001 0:00:00|SupplierINN=|SupplierKPP=|ShipperINN=|ShipperKPP=|\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Name\" value=\"Холодильник Стинол\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Manufacter\" value=\"НЛМК\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA5 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"print\">\n" +
            "\t<parameters>\n" +
            "\t\n" +
            "\t\t<parameter name=\"mytemplate3paramsv2\" type=\"template\">\n" +
            "\t\t\t<value type=\"variable\" name=\"QRCode\" value=\"Code=000004|UnitCode=715|Characteristic=40, Коричневый, 6, натуральная кожа|SerName=|SerNumber=|ProdDate=01.01.0001 0:00:00|ExpDate=01.01.0001 0:00:00|DocNo=|DocDate=01.01.0001 0:00:00|SupplierINN=|SupplierKPP=|ShipperINN=|ShipperKPP=|\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Name\" value=\"Холодильник Стинол\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Manufacter\" value=\"НЛМК\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA6 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"print\">\n" +
            "\t<parameters>\n" +
            "\t\n" +
            "\t\t<parameter name=\"TMH_Label_58_40\" type=\"template\">\n" +
            "\t\t\t<value type=\"variable\" name=\"QRCode\" value=\"Code=000004|UnitCode=715|Characteristic=40, Коричневый, 6, натуральная кожа|SerName=|SerNumber=|ProdDate=01.01.0001 0:00:00|ExpDate=01.01.0001 0:00:00|DocNo=|DocDate=01.01.0001 0:00:00|SupplierINN=|SupplierKPP=|ShipperINN=|ShipperKPP=|\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Name\" value=\"Х-67890 Стинол Завод бытовой техники\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Code\" value=\"это поле для кода\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"SerName\" value=\"Какое-то SerName\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"ExpDate\" value=\"ну допустим до 2077 г.\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Characteristic\" value=\"Характер нордический, стойкий\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Supplier\" value=\"Липецк\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Shipper\" value=\"Дальнобой\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"MeasureUnit\" value=\"тонны чугуния\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA7 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"print\">\n" +
            "\t<parameters>\n" +
            "\t\t<parameter type=\"template\" name=\"TMH_Label_58_40\">\n" +
            "\t\t\t<value type=\"variable\" name=\"QRCode\" value=\"Code=000004|UnitCode=715|Characteristic=40, Коричневый, 6, натуральная кожа|SerName=|SerNumber=|ProdDate=01.01.0001 0:00:00|ExpDate=01.01.0001 0:00:00|DocNo=|DocDate=01.01.0001 0:00:00|SupplierINN=|SupplierKPP=|ShipperINN=|ShipperKPP=|\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Name\" value=\"Мужские мокасины\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Code\" value=\"000004\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Characteristic\" value=\"40, Коричневый, 6, натуральная кожа\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"MeasureUnit\" value=\"пара (1 пара)\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"SerName\" value=\"\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"ExpDate\" value=\"\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Shipper\" value=\"\" length=\"0\"/>\n" +
            "\t\t\t<value type=\"variable\" name=\"Supplier\" value=\"\" length=\"0\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t<parameter type=\"quantity\" name=\"\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA_CUSTOM_COMMAND = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"custom_command\">\n" +
            "\t<parameters>\n" +
            "\t\t<parameter type=\"cmd\">\n" +
            "\t\t\t<value type=\"data\" value=\"^Q40,3\n" +
            "^W58\n" +
            "^H8\n" +
            "^P1\n" +
            "^S2\n" +
            "^AD\n" +
            "^C1\n" +
            "^R0\n" +
            "~Q+0\n" +
            "^O0\n" +
            "^D0\n" +
            "^E0\n" +
            "~R255\n" +
            "^L\n" +
            "Dy2-me-dd\n" +
            "Th:m:s\n" +
            "AD,45,29,1,1,0,0E,Тествая надпись\n" +
            "E\n" +
            "\"/>\n" +
            "\t\t</parameter>\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA_DOUBLE_CHECK = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"custom_command\">\n" +
            "\t<parameters>\n" +
            "\t\t<parameter type=\"cmd\">\n" +
            "\t\t\t<value type=\"data\" value=\"~S\n" +
            "\t\t\t~S\" />\n" +
            "\t\t</parameter>\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA_DOUBLE_CHECK2 = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"custom_command\">\n" +
            "\t<parameters>\n" +
            "\t\t<parameter type=\"cmd\">\n" +
            "\t\t\t<value type=\"data\" value=\"^XSET,IMMEDIATE,1\" />\n" +
            "\t\t</parameter>\n" +
            "\t</parameters>\n" +
            "</cmd>";

    private static final String DATA_DOUBLE_CHECK2_CR = "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n" +
            "<cmd name=\"custom_command\">\n" +
            "\t<parameters>\n" +
            "\t\t<parameter type=\"cmd\">\n" +
            "\t\t\t<value type=\"data\" value=\"^XSETCUT,DOUBLECUT,0\r" +
            "^Q60,3\r" +
            "^W100\r" +
            "^H15\r" +
            "^P1\r" +
            "^S4\r" +
            "^AD\r" +
            "^C1\r" +
            "^R0\r" +
            "~Q+0\r" +
            "^O0\r" +
            "^D0\r" +
            "^E0\r" +
            "~R255\r" +
            "^L\r" +
            "Dy2-me-dd\r" +
            "Th:m:s\r" +
            "V00,500,QRCode,jc50\r" +
            "V01,500,Name,jl50\r" +
            "V02,15,Code,jl8\r" +
            "V03,50,SerName,jl8\r" +
            "V04,50,ExpDate,jl8\r" +
            "V05,150,Characteristic,jl8\r" +
            "V06,150,Supplier,jl8\r" +
            "V07,150,Shipper,jl8\r" +
            "V08,50,MeasureUnit,jl8\r" +
            "W846,214,5,2,M0,8,5,4,0\r" +
            "Code=000004|UnitCode=715|Characteristic=40, Коричневый, 6, натуральная кожа|SerName=|SerNumber=|ProdDate=01.01.0001 0:00:00|ExpDate=01.01.0001 0:00:00|DocNo=|DocDate=01.01.0001 0:00:00|SupplierINN=|SupplierKPP=|ShipperINN=|ShipperKPP=|\r" +
            "R0,241,839,540,2,2\r" +
            "Lo,0,300,839,301\r" +
            "Lo,0,360,839,361\r" +
            "Lo,0,420,839,421\r" +
            "Lo,0,480,839,481\r" +
            "Lo,287,241,288,540\r" +
            "R0,539,1196,718,2,2\r" +
            "Lo,0,598,1196,599\r" +
            "Lo,0,658,1196,659\r" +
            "Lo,287,539,288,718\r" +
            "Lo,0,0,1,239\r" +
            "Lo,1195,0,1196,539\r" +
            "Lo,0,0,1199,1\r" +
            "AD,9,247,1,1,0,0E,Код АМТО\r" +
            "AD,9,313,1,1,0,0E,Ед. изм.\r" +
            "AD,9,370,1,1,0,0E,Серия\r" +
            "AD,9,432,1,1,0,0E,Поступление\r" +
            "AD,9,489,1,1,0,0E,Годен до\r" +
            "AD,9,552,1,1,0,0E,Характеристика\r" +
            "AD,9,610,1,1,0,0E,Грузоотправитель\r" +
            "AD,9,670,1,1,0,0E,Поставщик\r" +
            "AD,28,19,1,1,0,0E,Мужские мокасины\r" +
            "AD,303,254,1,1,0,0E,000004\r" +
            "AD,306,313,1,1,0,0E,пара (1 пара)\r" +
            "AD,304,371,1,1,0,0E,\r" +
            "AD,302,491,1,1,0,0E,\r" +
            "AD,304,552,1,1,0,0E,40, Коричневый, 6, натуральная кожа\r" +
            "AD,302,609,1,1,0,0E,\r" +
            "AD,301,669,1,1,0,0E,\r" +
            "E\"/>\r" +
            "\t\t</parameter>\n" +
            "\t\t<parameter name=\"\" type=\"quantity\">\n" +
            "\t\t\t<value type=\"count\" value=\"1\"/>\n" +
            "\t\t</parameter>\n" +
            "\t</parameters>\n" +
            "</cmd>";

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.xml_layout, container, false);

        printAdapter pa = printAdapter.getInstance(getActivity());

        CustomCommandBtn = view.findViewById(R.id.printCustomCommandBtn);

        CustomCommandBtn.setOnClickListener(view1 -> {

            pa.sendServiceCmd(DATA_CUSTOM_COMMAND);
        });

        doubleCheckStatusCommandBtn = view.findViewById(R.id.doubleCheckStatusCommandBtn);

        doubleCheckStatusCommandBtn.setOnClickListener(view1 -> {

            pa.sendServiceCmd(DATA_DOUBLE_CHECK2_CR);
        });

        return view;
    }

    @Override
    public String getPrintData() {
        return DATA7;
    }

    @Override
    public SparseArray<variable> getVariables() {
        variables.clear();
        return variables;
    }

    @Override
    public void PromptVariables(SparseArray<variable> vars) {

    }
}
